import { jsxs as p, jsx as c } from "react/jsx-runtime";
import s from "clsx";
/*!
  @versini/ui-toggle v1.1.0
  © 2024 gizmette.com
*/
try {
  window.__VERSINI_UI_TOGGLE__ || (window.__VERSINI_UI_TOGGLE__ = {
    version: "1.1.0",
    buildTime: "12/18/2024 12:35 PM EST",
    homepage: "https://github.com/aversini/ui-components",
    license: "MIT"
  });
} catch {
}
const b = "av-toggle", h = (e) => {
  let r = "";
  if (typeof e == "number" || typeof e == "string")
    r = "m-" + e;
  else {
    const t = [];
    (e == null ? void 0 : e.t) !== void 0 && t.push(`mt-${e.t}`), (e == null ? void 0 : e.r) !== void 0 && t.push(`mr-${e.r}`), (e == null ? void 0 : e.b) !== void 0 && t.push(`mb-${e.b}`), (e == null ? void 0 : e.l) !== void 0 && t.push(`ml-${e.l}`), r = t.join(" ");
  }
  return r;
}, m = () => s("peer", "h-6", "w-11", "rounded-full"), k = ({
  focusMode: e
}) => s(
  "peer-focus:outline",
  "peer-focus:outline-2",
  "peer-focus:outline-offset-2",
  {
    "peer-focus:outline-focus-dark": e === "dark",
    "peer-focus:outline-focus-light": e === "light",
    "peer-focus:outline-focus-light dark:peer-focus:outline-focus-dark": e === "alt-system",
    "peer-focus:outline-focus-dark dark:peer-focus:outline-focus-light": e === "system"
  }
), y = () => s(
  "peer-checked:after:translate-x-full",
  // background color when checked
  "peer-checked:bg-violet-500",
  // knob circle and border color when checked
  "peer-checked:after:bg-white",
  "peer-checked:after:border-white"
), x = () => s(
  "after:left-[2px]",
  "after:top-[2px]",
  "after:border",
  "after:border-surface-light dark:after:border-surface-medium",
  "after:bg-surface-light dark:after:bg-surface-medium",
  "after:absolute",
  "after:h-5",
  "after:w-5",
  "after:rounded-full",
  "after:transition-all",
  "after:content-['']"
), v = ({
  mode: e,
  noBorder: r
}) => s({
  border: !r,
  "border-border-dark bg-surface-medium": e === "light",
  "border-border-light bg-surface-darker": e === "dark",
  "border-border-light bg-surface-darker dark:border-border-dark dark:bg-surface-medium": e === "alt-system",
  "border-border-dark bg-surface-medium dark:border-border-light dark:bg-surface-darker": e === "system"
}), T = ({
  mode: e,
  labelHidden: r
}) => r ? "sr-only" : s("ml-2 text-sm", {
  "text-copy-dark": e === "light",
  "text-copy-lighter": e === "dark",
  "text-copy-lighter dark:text-copy-dark": e === "alt-system",
  "text-copy-dark dark:text-copy-lighter": e === "system"
}), _ = ({ spacing: e }) => s(
  b,
  "relative flex cursor-pointer items-center",
  h(e)
), w = ({
  mode: e,
  focusMode: r,
  labelHidden: t,
  spacing: l,
  noBorder: a
}) => ({
  toggle: s(
    m(),
    v({ mode: e, noBorder: a }),
    k({ focusMode: r }),
    x(),
    y()
  ),
  label: T({ mode: e, labelHidden: t }),
  input: "peer sr-only",
  wrapper: _({ spacing: l })
}), I = ({
  checked: e = !1,
  onChange: r,
  label: t,
  labelHidden: l = !1,
  name: a,
  mode: u = "system",
  focusMode: i = "system",
  spacing: n,
  noBorder: d = !1
}) => {
  const o = w({
    mode: u,
    focusMode: i,
    labelHidden: l,
    spacing: n,
    noBorder: d
  }), f = (g) => {
    r == null || r(g.target.checked);
  };
  return /* @__PURE__ */ p("label", { className: o.wrapper, children: [
    /* @__PURE__ */ c(
      "input",
      {
        name: a,
        checked: e,
        type: "checkbox",
        className: o.input,
        onChange: f
      }
    ),
    /* @__PURE__ */ c("div", { className: o.toggle }),
    /* @__PURE__ */ c("span", { className: o.label, children: t })
  ] });
};
export {
  b as TOGGLE_CLASSNAME,
  I as Toggle
};
